// Sharif Internet Contest 2008 (Nov 27 of 2008)
// A Soluton for Problem F (Friends For Sale)
// Author: Nima Ahmadi Pour Anari
#include <iostream>
#include <cmath>
#include <set>
using namespace std;
struct player{
	int owner;
	int cash;
	int value;
	player(){}
	player(int owner,int cash,int value):owner(owner),cash(cash),value(value){}
};
bool operator<(const player&  p1,const player& p2){
	if (p1.owner!=p2.owner)
		return p1.owner<p2.owner;
	if (p1.cash!=p2.cash)
		return p1.cash<p2.cash;
	return p1.value<p2.value;
}
int Round(double t){
	return round(t);
}
struct state{
	player p[3];
	int extra;
	state(){}
	state(player p1,player p2,player p3,int extra):extra(extra){
		p[0]=p1;
		p[1]=p2;
		p[2]=p3;
	}
	int& cash(int person){
		return person==3?extra:p[person].cash;
	}
	bool buy(int a,int b){
		if (a==b)
			return false;
		if (p[b].owner==a)
			return false;
		double val=p[b].value;
		cash(p[b].owner)+=Round(1.05*val);
		cash(b)+=Round(0.05*val);
		cash(a)-=Round(1.111*val);
		p[b].value=Round(1.1*val);
		if (cash(a)<-1e-6)
			return false;
		p[b].owner=a;
		return true;
	}
};
bool operator<(const state& s1,const state& s2){
	for (int i=0;i<3;++i)
		if (s1.p[i]<s2.p[i] || s2.p[i]<s1.p[i])
			return s1.p[i]<s2.p[i];
	return s1.extra<s2.extra;
}
istream& operator>>(istream& inp,state& s){
	for (int i=0;i<3;++i){
		inp>>s.p[i].value>>s.p[i].cash>>s.p[i].owner;
		--s.p[i].owner;
	}
	inp>>s.extra;
	return inp;
}
state s[50];
int b[50][2];
set<state> S;
bool good;
int ans;
void bt(int lev){
	if (lev==40)
		return;
	if (S.find(s[lev])!=S.end())
		return;
	S.insert(s[lev]);
	good=true;
	for (int i=0;i<3;++i)
		if (s[lev].p[i].owner==3){
			good=false;
			break;
		}
	if (good){
		int cur=min(min(s[lev].p[0].value,s[lev].p[1].value),s[lev].p[2].value);
		ans=max(ans,cur);
	}
	for (int i=0;i<4;++i)
		for (int j=0;j<3;++j){
			s[lev+1]=s[lev];
			if (s[lev+1].buy(i,j)){
				b[lev][0]=i;
				b[lev][1]=j;
				bt(lev+1);
			}
		}
}
int main(){
	int tnum;cin>>tnum;
	while (tnum--){
		S.clear();
		ans=0;
		cin>>s[0];
		bt(0);
		cout<<ans<<endl;
	}
	return 0;
}
