// Sharif Internet Contest 2008 (Nov 27 of 2008)
// A Soluton for Problem H (How to Dance a Robot)
// Author: Nima Ahmadi Pour Anari
#include <iostream>
#include <queue>
#include <algorithm>
#include <cstring>
using namespace std;
typedef pair<int,int> pint;
char tbl[10000];
int m,n;
int V(int i,int j){return i*n+j;}
int I(int v){return v/n;}
int J(int v){return v%n;}
bool inside(int i,int j){return i>=0 && i<m && j>=0 && j<n;}
char dir[4]={'E','N','S','W'};
const int mv[4][2]={{0,1},{-1,0},{1,0},{0,-1}};
int start;
int wanted;
queue<pint> q;
pint Parent[10000][256];
char Opc[10000][256];
char Direction[10000][256];
char& opc(const pint& p){return Opc[p.first][p.second];}
pint& parent(const pint& p){return Parent[p.first][p.second];}
char& direction(const pint& p){return Direction[p.first][p.second];}
pint nil(-1,-1);
int mult(int a,int b){return (a*b)&255;}
int add(int a,int b){return (a+b)&255;}
int sub(int a,int b){return (a-b)&255;}
typedef int(*binary_op)(int,int);
char opcode[3]={'*','+','-'};
binary_op ops[3]={mult,add,sub};
pint end;
int main(){
	// *+-
	int tnum;cin>>tnum;
	while (tnum--){
		cin>>m>>n;
		for (int i=0;i<m;++i)
			for (int j=0;j<n;++j)
				cin>>tbl[V(i,j)];
		{int i,j;cin>>i>>j;--i;--j;start=V(i,j);}
		cin>>wanted;
		while (!q.empty()) q.pop();
		memset(Parent,-1,sizeof Parent);
		pint P(start,tbl[start]-'0');
		parent(P)=P;
		q.push(P);
		end=nil;
		while (!q.empty()){
			pint v=q.front();q.pop();
			if (v.second==wanted){
				end=v;
				break;
			}
			int i=I(v.first),j=J(v.first);
			for (int d=0;d<4;++d){
				int ni=i+mv[d][0];
				int nj=j+mv[d][1];
				if (!inside(ni,nj) || tbl[V(ni,nj)]=='*')
					continue;
				int nv=V(ni,nj);
				for (int op=0;op<3;++op){
					pint newv(nv,ops[op](v.second,tbl[nv]-'0'));
					if (parent(newv)==nil){
						parent(newv)=v;
						opc(newv)=opcode[op];
						direction(newv)=dir[d];
						q.push(newv);
					}
				}
			}
		}
		if (end!=nil){
			string res="";
			for (pint v=end;v!=P;v=parent(v)){
				res+=opc(v);
				res+=direction(v);
			}
			reverse(res.begin(),res.end());
			cout<<res<<endl;
		}
		else{
			cout<<"No Solution"<<endl;
		}
	}
	return 0;
}
